## oneclient-base 18.02.2.6.g9a4e6c2

=== debian/changelog ===
oneclient-base (18.02.2.6.g9a4e6c2-1) xenial; urgency=low

  * Build from 18.02.2.6.g9a4e6c2

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 14 Jun 2019 13:44:55 +0200
