## oneclient-base 19.02.5

=== debian/changelog ===
oneclient-base (19.02.5-1~bionic) bionic; urgency=low

  * Build from 19.02.5

 -- Onedata Package Maintainer <support@onedata.org>  Tue, 10 Nov 2020 22:37:34 +0100
