=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
     cmake (>= 3.0.0),
     debhelper (>= 9),
     folly-dev,
-    g++-5 (>= 5.0.0),
+    g++-7,
     git,
     glusterfs-common (>= 3.12.1),
     golang-go,
@@ -21,13 +21,13 @@
     libltdl-dev,
     libnspr4-dev,
     libnss3-dev,
-    libprotobuf-dev (>= 3.4.1),
+    libprotobuf-dev (>= 3.0.0),
     librados-dev (>= 12.2.1),
     libradosstriper-dev (>= 12.2.1),
     libsodium-dev,
     libssl-dev (>= 1.1.0),
-    libstdc++-5-dev,
-    libtbb-dev (>= 2018~U5),
+    libstdc++-7-dev,
+    libtbb-dev,
     libpoco-dev,
     libpocofoundation50,
     libpoconetssl50,
@@ -35,7 +35,7 @@
     libpocoxml50,
     openssl (>= 1.1.0),
     pkg-config,
-    protobuf-compiler (>= 3.4.1),
+    protobuf-compiler (>= 3.0.0),
     python-dev,
     python3-dev,
     subversion,
@@ -55,14 +55,14 @@
 
 Package: python-onedatafs
 Architecture: amd64
-Depends: python, libboost-python1.58.0, ${shlibs:Depends}, ${misc:Depends}
+Depends: python, libboost-python1.65.1, ${shlibs:Depends}, ${misc:Depends}
 Description: FUSE client for onedata system.
  oneclient is a software based on FUSE (Filesystem in Userspace) that allows
  mounting onedata filesystem on Linux systems.
 
 Package: python3-onedatafs
 Architecture: amd64
-Depends: python3, libboost-python1.58.0, ${shlibs:Depends}, ${misc:Depends}
+Depends: python3, libboost-python1.65.1, ${shlibs:Depends}, ${misc:Depends}
 Description: FUSE client for onedata system.
  oneclient is a software based on FUSE (Filesystem in Userspace) that allows
  mounting onedata filesystem on Linux systems.
